> ## Documentation Index
> Fetch the complete documentation index at: https://kosli-reference-docs-v2-30-1.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# List decisions for a control

> **Beta** — the Controls feature is in beta. Requests from organizations without it enabled receive `403 Forbidden`.



## OpenAPI

````yaml https://app.kosli.com/api/v2/openapi.json get /controls/{org}/{identifier}/decisions
openapi: 3.1.0
info:
  title: Kosli API
  summary: The API for communicating with Kosli
  description: >

    # Authentication 


    When making requests against Kosli API, you can authenticate your requests
    using a bearer token. 

    Set the bearer token in the request Authorization header to a valid API
    key. 

    API Keys can be personal or for service accounts. Check the [service
    accounts
    documentation](https://docs.kosli.com/getting_started/service-accounts/) for
    details. 


    ## Curl example


    ```shell

    curl -H "Authorization: Bearer <<your-api-key>>"
    https://app.kosli.com/api/v2/environments/<<your-org-name>>

    ```
  version: '2.0'
servers:
  - url: https://app.kosli.com/api/v2
    description: EU
  - url: https://app.us.kosli.com/api/v2
    description: US
security:
  - HTTPBearer: []
paths:
  /controls/{org}/{identifier}/decisions:
    get:
      tags:
        - Controls
      summary: List decisions for a control
      description: >-
        **Beta** — the Controls feature is in beta. Requests from organizations
        without it enabled receive `403 Forbidden`.
      operationId: list_control_decisions
      parameters:
        - name: identifier
          in: path
          required: true
          schema:
            type: string
            title: Identifier
        - name: org
          in: path
          required: true
          schema:
            type: string
            title: Org
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            description: Page number
            default: 1
            title: Page
          description: Page number
        - name: per_page
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 1
            description: Number of decisions per page
            default: 15
            title: Per Page
          description: Number of decisions per page
        - name: is_compliant
          in: query
          required: false
          schema:
            anyOf:
              - type: boolean
              - type: 'null'
            description: Filter by compliance status
            title: Is Compliant
          description: Filter by compliance status
        - name: from_timestamp
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: 'null'
            description: Filter decisions recorded at or after this Unix timestamp
            title: From Timestamp
          description: Filter decisions recorded at or after this Unix timestamp
        - name: to_timestamp
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: 'null'
            description: Filter decisions recorded at or before this Unix timestamp
            title: To Timestamp
          description: Filter decisions recorded at or before this Unix timestamp
        - name: flow_id
          in: query
          required: false
          schema:
            anyOf:
              - items:
                  type: string
                type: array
              - type: 'null'
            description: >-
              Filter decisions to these flows. Can be repeated, e.g.
              flow_id=<id1>&flow_id=<id2>
            title: Flow Id
          description: >-
            Filter decisions to these flows. Can be repeated, e.g.
            flow_id=<id1>&flow_id=<id2>
        - name: sort_direction
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/SortDirection'
            description: 'Sort by decision time: desc (newest first) or asc (oldest first)'
            default: desc
          description: 'Sort by decision time: desc (newest first) or asc (oldest first)'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DecisionListResponse'
        '403':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/fastapi_app__errors__ForbiddenResponse___locals___ForbiddenResponseModel__10
          description: Forbidden
        '404':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/fastapi_app__errors__NotFoundResponse___locals___NotFoundResponseModel__43
          description: Not Found
      security:
        - HTTPBearer: []
        - HTTPBasic: []
components:
  schemas:
    SortDirection:
      type: string
      enum:
        - asc
        - desc
      title: SortDirection
    DecisionListResponse:
      properties:
        _links:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Links
        page:
          type: integer
          title: Page
        per_page:
          type: integer
          title: Per Page
        total_pages:
          type: integer
          title: Total Pages
        total_count:
          type: integer
          title: Total Count
        decisions:
          items:
            $ref: '#/components/schemas/DecisionListItemResponse'
          type: array
          title: Decisions
      additionalProperties: false
      type: object
      required:
        - page
        - per_page
        - total_pages
        - total_count
        - decisions
      title: DecisionListResponse
    fastapi_app__errors__ForbiddenResponse___locals___ForbiddenResponseModel__10:
      properties:
        message:
          type: string
          title: Message
          description: Error message
        errors:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Errors
          description: Validation errors by field
      type: object
      required:
        - message
      title: ForbiddenResponseModel
      examples:
        - message: You don't have permission to access this resource
    fastapi_app__errors__NotFoundResponse___locals___NotFoundResponseModel__43:
      properties:
        message:
          type: string
          title: Message
          description: Error message
        errors:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Errors
          description: Validation errors by field
      type: object
      required:
        - message
      title: NotFoundResponseModel
      description: Control not found
      examples:
        - message: Control not found
    DecisionListItemResponse:
      properties:
        attestation_id:
          type: string
          title: Attestation Id
        created_at:
          type: number
          title: Created At
        is_compliant:
          type: boolean
          title: Is Compliant
        control_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Control Version
        attestation_name:
          type: string
          title: Attestation Name
        artifact_fingerprint:
          anyOf:
            - type: string
              pattern: ^[a-f0-9]{64}$
            - type: 'null'
          title: Artifact Fingerprint
        artifact_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Artifact Name
        flow_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Flow Name
        trail_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Trail Name
      type: object
      required:
        - attestation_id
        - created_at
        - is_compliant
        - attestation_name
      title: DecisionListItemResponse
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````